{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}
const
  infile = 'input.txt';
  outfile = 'output.txt';
  maxa = 15001;

type
  Atom = array [0..maxa] of longint;
  PAtom = ^Atom;
  TKewl = array [0..1] of PAtom;
  Atom1 = array [0..2*maxa] of integer;
  PAtom1 = ^Atom1;
var
  fi, fo : text;
  nums : array [0..2*maxa] of integer;
  sums : TKewl;
  A : PAtom1;
  M, S : longint;

procedure ReadData;
var
  i : longint;
begin
  new(sums[0]); new(sums[1]);
  new(A);
  sums[0]^[0] := 0; sums[1]^[0] := 0;
  A^[0] := 0;
  nums[0] := 0;
  readln(fi, M, S);
  for i := 1 to M do begin
    Readln(fi, A^[i]);
    sums[i mod 2]^[i div 2] := A^[i] + sums[(i-1) mod 2]^[(i-1) div 2] + 10000;
    nums[i] := i;
  end;
end;

procedure qsort(l, r : integer);
var
  i, j : integer;
  w, x : longint;
begin
  i := l;
  j := r;
  x := sums[((i+j)div 2) mod 2]^[((i+j)div 2) div 2];
  repeat
    while sums[i mod 2]^[i div 2] < x do i := i + 1;
    while sums[j mod 2]^[j div 2] > x do j := j - 1;
    if i <= j then begin
      w := sums[i mod 2]^[i div 2];
      sums[i mod 2]^[i div 2] := sums[j mod 2]^[j div 2];
      sums[j mod 2]^[j div 2] := w;
      w := nums[i]; nums[i] := nums[j]; nums[j] := w;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if (i < r) then qsort(i, r);
  if (j > l) then qsort(l, j);
end;

procedure main;
var
  i, j, i1, i2, maxlen, resi : longint;
  Sum, curlen : longint;
begin
  maxlen := -1; resi := M + 1;
  i := 1; j := 1;
  while (i <= M) and (j <= M) do begin
    if i <= j then begin
      i1 := i; i2 := j;
    end else begin
      i1 := i; i2 := j;
    end;
    Sum := sums[i2 mod 2]^[i2 div 2] - sums[(i1 - 1) mod 2]^[(i1 - 1) div 2];
    curlen := (i2 - i1 + 1);
    Sum := Sum - (i2 - i1 + 1)*10000;
    if Sum = S then begin
      if curlen > maxlen then begin
        maxlen := curlen;
        resi := i1;
      end else if curlen = maxlen then begin
        if resi > i1 then resi := i1;
      end;
      j := j + 1;
    end else
    if Sum < S then begin
      j := j + 1;
    end else
    if Sum > S then begin
      i := i + 1;
    end;
  end;
  if maxlen < 0 then begin
    writeln(fo, '0 0');
  end else begin
    writeln(fo, resi, ' ', maxlen);
  end;
end;

begin
  assign(fi, infile); assign(fo, outfile);
  reset(fi); rewrite(fo);
  ReadData;
{  qsort(1, M);}
  main;
  close(fi); close(fo);
end.