#include <stdio.h>
#include <string.h>


extern unsigned _stklen = 60000U;
struct queue
{
	queue() {head=tail=0;}
	int empty() {return head==tail;}
	void push( unsigned char v ) {data[head++]=v;head%=10000;}
	unsigned char pop() {unsigned char v=data[tail++];tail%=10000;return v;}
	unsigned char data[10000];
	int head, tail;
};

int n, m;
char map[210][210];

int main()
{
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );

	scanf( "%d %d\n", &n, &m );
	memset( map, 0, sizeof(map) );

	int row, col;
	for( row = 0; row < n; ++row )
	{
		for( col = 0; col < m; ++col )
		{
			scanf( "%c", &map[row][col] );
		}
		scanf( "\n" );
	}

	queue qr, qc;
	map[0][0] = ',';
	qr.push(0);
	qc.push(0);

	long res = 0;

	while( !qr.empty() )
	{
		row = qr.pop();
		col = qc.pop();

		if( row > 0 )
		{
			if( map[row-1][col] == '.' )
			{
				map[row-1][col] = ',';
				qr.push(row-1);
				qc.push(col);
			}
			else if( map[row-1][col] == '*' )
			{
				map[row-1][col] = '#';
				++res;
			}
		}

		if( col > 0 )
		{
			if( map[row][col-1] == '.' )
			{
				map[row][col-1] = ',';
				qr.push(row);
				qc.push(col-1);
			}
			else if( map[row][col-1] == '*' )
			{
				map[row][col-1] = '#';
				++res;
			}
		}

		if( row < n )
		{
			if( map[row+1][col] == '.' )
			{
				map[row+1][col] = ',';
				qr.push(row+1);
				qc.push(col);
			}
			else if( map[row+1][col] == '*' )
			{
				map[row+1][col] = '#';
				++res;
			}
		}

		if( col < m )
		{
			if( map[row][col+1] == '.' )
			{
				map[row][col+1] = ',';
				qr.push(row);
				qc.push(col+1);
			}
			else if( map[row][col+1] == '*' )
			{
				map[row][col+1] = '#';
				++res;
			}
		}

	}

	printf( "%ld", res );

	fclose( stdout );
	fclose( stdin );
	return 0;
}