#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

const long LEN = 1100;
const long MAX = 210;

bool finish = false;
long caseNo = 0;
long N, M;
char A[MAX][MAX];

struct qq {
	short r, c;
} st[LEN];

qq st2[LEN];
long count, count2;


void Input()
{
	cin >> N >> M;
	for (long i = 0; i < N; i++)
		for (long j = 0; j < M; j++)
			{
				cin >> A[i][j];
			}
}


bool test (long r, long c) {
	if (A[r][c] != '*')
		return 0;

	for (long i = -1; i < 2; i++)
		for (long j = -1; j < 2; j++)
			if (abs(i) + abs(j) == 1)
				if (((r + i) >= 0) &&
					((r + i) < N) &&
					((c + j) >= 0) &&
					((c + j) < M))
					if (A[r + i][c + j] == '+')
						return true;

	return false;

}

void add (long r, long c) {
			for (long i = -1; i < 2; i++)
				for (long j = -1; j < 2; j++)
					if (abs(i) + abs(j) == 1)
						if (((r + i) >= 0) &&
							((r + i) < N) &&
							((c + j) >= 0) &&
							((c + j) < M))
							if (A[r + i][c + j] == '.')
								{
									st[count].r = r + i;
									st[count].c = c + j;
									A[r + i][c + j] = '+';
									count++;
								}

}

void Solve()
{
	count = 1;
	A[0][0] = '+';
	st[0].r = 0;
	st[0].c = 0;
	while (count)
		{
			memcpy(st2, st, count * sizeof st[0]);
			count2 = count;
			count = 0;
			for (long k = 0; k < count2; k++)
				add(st2[k].r, st2[k].c);
		}

	count = 0;
	for (long i = 0; i < N; i++)
		for (long j = 0; j < M; j++)
			if (test(i,j))
				count++;
}

void Output()
{
	cout << count << endl;
}


int main()
{
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
	cout = os;

		Input();
		Solve();
		Output();

	return 0;
}