var
   data: array [1..100] of string;
   n, i, j, r, rows: integer;
   none: boolean;
   width: array [1..100] of integer;
   s: string;

function getWord(r, c: integer): string;
var
   i: integer;
   rr: string;
begin
   i := 1;
   dec(r);
   while (i <= length(data[c])) and (r > 0) do begin
      if data[c][i] = ',' then
         dec(r);
      inc(i);
   end;
   rr := '';
   while (i <= length(data[c])) and (data[c][i] <> ',') do begin
      rr := rr + data[c][i];
      inc(i);
   end;
   getWord := rr;
end;

procedure rpad(var s: string; l: integer);
begin
   while length(s) < l do
      s := s + ' ';
end;

begin
   Assign(input, 'input.txt');
   Assign(output, 'output.txt');
   Reset(input);
   Rewrite(output);

   n := 0;
   while not eof do begin
      inc(n);
      readln(data[n]);
   end;

   for i := 1 to n do
      width[i] := 0;

   rows := 0;
   for r := 1 to 100 do
      for i := 1 to n do begin
         s := getWord(r, i);
         if s <> '' then begin
            if r > rows then
               rows := r;
            if length(s) > width[i] then
               width[i] := length(s);
         end;
      end;

   for r := 1 to rows do begin
      for i := n downto 1 do begin
         s := getWord(r, i);
         if s <> '' then begin
            none := false;
            break;
         end;
      end;
      for j := 1 to i do begin
         s := getWord(r, j);
         if j <> i then
            rpad(s, width[j]);
         if j > 1 then
            write(' ');
         write(s);
      end;
      writeln;
   end;

   Close(input);
   Close(output);
end.