{$A+,B+,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}

Type
  tMyLine=array[byte]of
    record
      s:longint;
      ind:integer;
    end;
  PMyLine=^TMyLine;

  tMyLine2=array[byte]of longint;
  PMyLine2=^TMyLine2;

Var
  p:array[byte]of PMyLine;
  p2:array[byte] of PMyLine2;

  i,j:integer;

  t:integer;

  M:integer;
  S:integer;
  csum:integer;

  Src,Dst:integer;
  SrcS:longint;
  LeftMostInd:integer;

  MLi,MLj:integer;

  MaxLeng:integer;

Procedure SetInd(i:integer;ival:integer);
begin
  p[i shr 8]^[i and 255].ind:=ival
end;

Function GetInd(i:integer):integer;
begin
  GetInd:=p[i shr 8]^[i and 255].ind
end;

Procedure SetS(i:integer;sval:longint);
begin
  p[i shr 8]^[i and 255].s:=sval
end;

Function GetS(i:integer):longint;
begin
  getS:=p[i shr 8]^[i and 255].s
end;

procedure StoreSum(i:integer;sval:longint);
begin
  p2[i shr 8]^[i and 255]:=sval;
end;

function RetrieveSum(i:integer):longint;
begin
  RetrieveSum:=p2[i shr 8]^[i and 255];
end;

procedure BinSearch(sumreq:longint;var storedindex:integer);
var L,R:integer;
    S:longint;
begin
  R:=Dst;
  L:=0;
  repeat
    StoredIndex:=(L+R)div 2;
    S:=getS(StoredIndex);
    if S=sumreq then
      begin
        StoredIndex:=getInd(StoredIndex);
        exit
      end;
    if S>sumreq then R:=StoredIndex-1 else L:=StoredIndex+1;
  until (L>=R)or(R<0)or(L>M);
  if L>M then begin
    storedindex:=maxint;
    exit
    end;
  S:=getS(L);
  if S=sumreq
  then  StoredIndex:=getInd(L)
  else  StoredIndex:=maxint;
end;

Procedure Sort(l,r:integer);
var ti,xn,n,l1,r1:integer;
    ts,xs:longint;
begin
  if l>=r then exit;
  l1:=l;r1:=r;
  n:=(l+r) div 2;
  xn:=GetInd(n);xs:=GetS(n);
  repeat
    while (GetS(l)<xs) or ((GetS(l)=xs) and (GetInd(l)<xn)) do inc(l);
    while (GetS(r)>xs) or ((GetS(r)=xs) and (GetInd(r)>xn)) do dec(r);
    if (l<n) and (r>n) then begin
      ts:=GetS(l);ti:=GetInd(l);
      SetS(l,getS(r));SetInd(l,getInd(r));SetS(l,ts);SetInd(l,ti);
    end
    else
      if (l<n) then
        begin
          ts:=GetS(l);ti:=GetInd(l);
          SetS(l,getS(n));SetInd(l,getInd(n));SetS(l,ts);SetInd(l,ti);
        end
      else break;
  until false;

  Sort(l1,l);
  Sort(l,r1);
end;

procedure QuickSort;
begin
  Sort(0,dst);
end;


{procedure QuickSort;
var
  mins,ts,s:longint;
  mini,ti:integer;
  i,j:integer;

begin
  for i:=0 to M do
   begin
    mins:=gets(i);
    ts:=mins;
    mini:=i;
    ti:=getind(i);
    for j:=i+1 to M do
    begin
      S:=gets(j);
      if s<=mins then
        if s<mins then
          begin
            mins:=s;
            mini:=j;
          end
        else if getind(j)<getind(mini) then mini:=j;
    end;
    sets(i,mins);
    setind(i,getind(mini));
    sets(mini,ts);
    setind(mini,ti);
   end;
end;}

begin
  assign(input,'input.txt');reset(input);
  assign(output,'output.txt');rewrite(output);

  readln(M,S);
  for i:=0 to M shr 8 do new(p[i]);
  for i:=0 to M shr 8 do new(p2[i]);

  SetInd(0,0);
  SetS(0,0);
  StoreSum(0,0);
  csum:=0;
  for i:=1 to M do
    begin
      read(t);
      SetInd(i,i);
      inc(csum,t);
      SetS(i,csum);
      StoreSum(i,csum);
    end;

  QuickSort;

  Src:=0;
  Dst:=0;
  SetS(M+1,maxlongint);
  repeat
    SrcS:=GetS(Src);
    LeftMostInd:=GetInd(src);
    while GetS(src)=srcs do inc(src); {skip}
    SetS(Dst,Srcs);
    SetInd(Dst,LeftMostInd);
    inc(dst);
  until src>M;

  dec(dst); {bound!}

  MLi:=0;MLj:=0;
  MaxLeng:=0;
  for i:=1 to M do
    begin
      BinSearch(RetrieveSum(i)-S,j);
      if (j<>maxint)and(i>j) then
        if i-j>MaxLeng then
         begin
           MaxLeng:=i-j;
           MLi:=i;
           MLj:=j;
         end;
    end;

  if maxleng=0 then
    writeln('0 0')
  else
    Writeln(MLj+1,' ',MaxLeng);

  close(input);close(output);
end.
