{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
type
  tdir=(none,left,top,right,bottom);
  tmap=array[1..200,1..200] of char;
  tset=array[1..200,1..200] of set of tdir;
  tstack=array[0..65530] of tdir;
const
  d:array[tdir] of record dx,dy:integer end=
    ((dx:0;dy:0),(dx:0;dy:-1),(dx:-1;dy:0),(dx:0;dy:1),(dx:1;dy:0));
var
  stack:^tstack; ns:word;
  theset:^tset;
  map:^tmap;
  n,m:integer;
procedure push(x:tdir);
begin
  stack^[ns]:=x; inc(ns);
end;
function pop:tdir;
begin
  dec(ns); pop:=stack^[ns];
end;
function peekpop:tdir;
begin
  peekpop:=stack^[ns-1];
end;
function empty:boolean;
begin
  empty:=ns=0;
end;
function inverse(x:tdir):tdir;
begin
  case x of
    left: inverse:=right;
    right: inverse:=left;
    top: inverse:=bottom;
    bottom: inverse:=top;
  else inverse:=x;
  end;
end;
procedure paint;
label label1;
var
  from,i:tdir; x,y:integer;
begin
  ns:=0; i:=left; x:=1; y:=1;
  repeat
label1:
    map^[x,y]:='!';
    if not empty then from:=peekpop else from:=none;
    while i<=bottom do begin
      if (i<>from) and (i in theset^[x,y]) and
       (map^[x+d[i].dx,y+d[i].dy]='.') then begin
        push(inverse(i)); inc(x,d[i].dx); inc(y,d[i].dy); i:=left;
        goto label1;
      end;
      inc(i);
    end;
    if empty then break;
    i:=inverse(pop); dec(x,d[i].dx); dec(y,d[i].dy);
  until false;
end;

var
  i,j:integer; k:tdir;
  count:integer; flag:boolean;
begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  new(theset); {fillchar(theset^,sizeof(theset^),char);}
  new(stack); ns:=0;
  new(map); fillchar(map^,sizeof(map^),0);
  readln(n,m);
  for i:=1 to n do begin
    for j:=1 to m do begin
      read(map^[i,j]);
      theset^[i,j]:=[left,top,right,bottom];
    end;
    readln;
  end;
  for j:=1 to m do begin
    Exclude(theset^[1,j],top);
    Exclude(theset^[n,j],bottom);
  end;
  for i:=1 to n do begin
    Exclude(theset^[i,1],left);
    Exclude(theset^[i,m],right);
  end;
  paint;
{  for i:=1 to n do begin
    for j:=1 to m do
      write(map^[i,j]);
    writeln;
  end;}
  count:=0;
  for i:=2 to n-1 do
    for j:=2 to m-1 do begin
      flag:=false;
      for k:=left to bottom do
        if (map^[i,j]='*') and (map^[i+d[k].dx,j+d[k].dy]='!')
          then flag:=true;
      if flag then inc(count);
    end;
  writeln(count);
  close(input); close(output);
end.