{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
Program Beach;
const
     maxN = 202;
type
    TMap = array[0..maxN,0..maxN] of char;
    TBusy = array[0..maxN,0..maxN] of char;
    PQ = ^TQ;
    TQ = record
         x,y : Integer;
         pr : PQ;
    end;
var
   Map : TMap;
   iq,oq : PQ;
   Sx,Sy : Integer;
   Res: Longint;

Procedure AddQ(x,y : Integer);
var
   t : PQ;
Begin
     New(t);
     t^.x:=x; t^.y:=y;
     t^.pr:=nil;
     if iq=nil then oq:=t
               else iq^.pr:=t;
     iq:=t;
end;

Procedure OutQ;
var
   t : PQ;
Begin
     if oq=nil then EXIT;
     t:=oq;
     if oq=iq then iq:=nil;
     oq:=oq^.pr;
     Dispose(t);
end;

Procedure InpData;
var
   x,y,i : Integer;
Begin
     Assign(input,'input.txt');
     Reset(input);
     Readln(Sy,Sx);
     for y:=1 to Sy do
     begin
         for x:=1 to Sx do
             Read(Map[x,y]);
         Readln;
     end;
     Close(input);
     for i:=0 to Sy do
     begin
          Map[0,i]:='#';
          Map[Sx+1,i]:='#';
     end;
     for i:=0 to Sx do
     begin
          Map[i,0]:='#';
          Map[i,Sy+1]:='#';
     end;
end;

Procedure Process(x,y : Integer);
Begin
     If Map[x,y]='#' then EXIT;
     If Map[x,y]='.' then AddQ(x,y)
                     else inc(Res);
     Map[x,y]:='#';
end;

Procedure Solve;
Begin
     AddQ(1,1);
     Map[1,1]:='#';
     While oq<>nil do
     with oq^ do
     begin
          Process(x+1,y);
          Process(x-1,y);
          Process(x,y+1);
          Process(x,y-1);
          OutQ;
     end;
end;

Begin
     iq:=nil; oq:=nil;
     InpData;
     Res:=0;
     Solve;
     Assign(output,'output.txt');
     Rewrite(output);
     Writeln(Res);
     Close(output);
end.