{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 65520,0,655360}
program The_Beach;

const
  maxn = 200;
  maxm = 200;

type
  tarray = array[1..60000] of byte;

var
  n,m,i,j,s: integer;
  a: array[1..maxn,1..maxm] of char;
  sx,sy: ^tarray;

procedure fill1(x0,y0: integer);
var
  size,x,y: integer;
function can(x,y: integer): boolean;
begin
  can:=(x>=1) and (x<=n) and (y>=1) and (y<=m) and (a[x,y]='.');
end;
begin
  size:=1;
  sx^[1]:=x0;
  sy^[1]:=y0;
  a[x0,y0]:='+';
  while size<>0 do begin
    x:=sx^[size];
    y:=sy^[size];
    dec(size);
    if can(x-1,y) then begin
      inc(size);
      sx^[size]:=x-1;
      sy^[size]:=y;
      a[x-1,y]:='+';
    end;
    if can(x+1,y) then begin
      inc(size);
      sx^[size]:=x+1;
      sy^[size]:=y;
      a[x+1,y]:='+';
    end;
    if can(x,y-1) then begin
      inc(size);
      sx^[size]:=x;
      sy^[size]:=y-1;
      a[x,y-1]:='+';
    end;
    if can(x,y+1) then begin
      inc(size);
      sx^[size]:=x;
      sy^[size]:=y+1;
      a[x,y+1]:='+';
    end;
  end;
end;

begin
  assign(input,'input.txt');  reset(input);
  assign(output,'output.txt');  rewrite(output);
  readln(n,m);
  for i:=1 to n do begin
    for j:=1 to m do read(a[i,j]);
    readln;
  end;
  new(sx);
  new(sy);
  fill1(1,1);
  s:=0;
  for i:=2 to n-1 do
    for j:=2 to m-1 do
      if (a[i,j]='*') and
((a[i-1,j]='+') or (a[i+1,j]='+') or (a[i,j-1]='+') or (a[i,j+1]='+')) then
        inc(s);
  writeln(s);
  close(input);  close(output);
end.
