#include <stdio.h>
#include <stdlib.h>

extern unsigned _stklen = 60000U;

long* arrs[4];

long get_ar(long index)
{
	if(index < 12500)return arrs[0][index];
	else if(index < 25000)return arrs[1][index - 12500];
	else if(index < 37500)return arrs[2][index - 25000];
	else return arrs[3][index - 37500];
}

void set_ar(long index, long value)
{
	if(index < 12500)arrs[0][index] = value;
	else if(index < 25000)arrs[1][index - 12500] = value;
	else if(index < 37500)arrs[2][index - 25000] = value;
	else arrs[3][index - 37500] = value;
}

void swap(long index1, long index2)
{
	long x = get_ar(index1);
	set_ar(index1, get_ar(index2));
    set_ar(index2, x);
}

long t,del;
void qsort(long M,long N)
{
	if(N<=M+1)return;
	long m=M,n=M,p=N;
	del = get_ar(M+random(N-M));
	while(n!=p)
	{
		t = get_ar(n);
		if(t > del)swap(n,--p);
		else if(t == del)++n;
		else if(t < del)swap(m++,n++);
	}
	if(N-p>m-M)
	{
		qsort(M,m);
		qsort(p,N);
	}
	else
	{
		qsort(p,N);
		qsort(M,m);
	}
}

char Gr[50000];

long mid,left,right,vl;
long search(long beg,long end,long val)
{
	while(beg < end)
	{
		mid = (beg + end) >> 1;
		while(get_ar(mid)==-1&&mid!=beg)--mid;
		vl = get_ar(mid);
		if(vl == val) return mid;

		if(vl < val)beg = mid + 1;
		else end = mid;
	}
	return -1;
}

char gused[5]={0,0,0,0,0};

int main()
{
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );

	long i;
	for(i=0;i<4;++i)
	{
		arrs[i] = new long[12500];
		if(!arrs[i])
		{
			printf("Crash!!!\n");
			return 1;
		}
	}

	long M,G,g;
	scanf("%ld %ld",&M,&G);

	for(i=0;i<M;++i)
	{
		scanf("%ld",&t);
		set_ar(i,t);
		Gr[i]=100;
	}

	qsort(0,M);

	long Index,Index2,val,gval,ui,j;
	for(i=0;i<M;++i)
	if(Gr[i]==100)
		{
			//if(!(i&63L))fprintf(stderr,"%ld\n",i);
			long ctr=0;

			val = get_ar(i);
			gval = val;
			for(g=1;g<=G;++g)
			{
				Index = search(i+1,M,gval);
				if(Index == -1 || Gr[Index]!=100)
				{
					gval += val;
					continue;
				}
				for(Index2 = Index; Index2 < M; ++Index2)
					if(get_ar(Index2) != gval)break;
					else
					{
						Gr[Index2]=++ctr;
					}
				for(Index2 = Index-1; Index2 >= 0; --Index2)
					if(get_ar(Index2) != gval)break;
					else
					{
						Gr[Index2]=++ctr;
					}
				gval += val;
			}
		}

	freopen("input.txt","rt",stdin);

	scanf("%ld %ld",&M,&G);
	for(i=0;i<M;++i)
	{
		scanf("%ld",&t);
		Index = search(0,M,t);
		printf("%ld\n",long(Gr[Index]));
		set_ar(Index,-1);
	}

	for(i=0;i<4;++i)
		delete[] arrs[i];

	fclose( stdout );
	fclose( stdin );
	return 0;
}