#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

bool finish = false;
long caseNo = 0;
const long PRIMES = 3300;
const long MAXINT = 30000;
const long MAX = 1000;
int primes[PRIMES];
long nprimes;
long K, N;
long divs[10];
long prev;
char used[MAXINT];

struct qq {
	short head, tail;
	short data[MAX];
	void operator -= (long& n) {
		n = data[head];
		head++;
		head = head % MAX;
	}
	void operator += (long n) {
/*		if (head == tail)
		  { data[0] = n;
		    head = 0;
		    tail = 1;
		  }
		else
		 {*/
			data[tail] = n;
			tail++;
			tail = tail % MAX;
//		}
	}
	long top () {return data[head];}
}o[5];

void Init(){
	primes[0] = 2;
	nprimes = 1;
	for (long i = 3; i <= MAXINT; i+=2){
		bool OK = true;
		for (long j = 0; j < nprimes; j++)
			if (!(i % primes[j])){
				OK = false;
				break;
			}
		if (OK)
			primes[nprimes++] = i;
	}
}

void Input()
{
	cin >> K >> N;
}

void Fact(long n, long& cnt){
	memset(divs, 0, sizeof divs);
	cnt = 0;
	for (long i = 0; i < nprimes && n >= primes[i]; i++){
		if (!(n % primes[i]))
			divs[cnt++] = primes[i];
	}
}

long GCD(long a, long b){
	while(b){
		long t = a;
		a = b;
		b = t % b;
	}
	return a;
}

long Min(long cnt){
	long min = 0;
	for (long i = 1; i < cnt; i++)
		if (o[min].top() > o[i].top())
			min = i;
	return min;
}

void Add(long k, long cnt){
	for (long i = 0; i < cnt; i++)
		o[i]+=k + divs[i];
}

void Gen(){
	long cnt;
	Fact(prev, cnt);
//	memset(o, 0, sizeof o);
	for (long i = 0; i < cnt; i++){
		o[i].data[0] = 0;
		o[i].head = 0;
		o[i].tail = 1;
	}
	for (i = 0; i < cnt; i++)
		o[i] += divs[i];
	long k = Min(cnt);
	long n;
	o[k]-=n;
	n += divs[k];
	if (n <= MAXINT)
		o[k] += n;
	while (used[n] || GCD(n, prev) < K){
		k = Min(cnt);
		o[k]-=n;
		n += divs[k];
		if (n <= MAXINT)
			o[k] += n;
	}
	prev = n;
}

void Solve(){
	long n, i;
	for (i = 1; i <= K; i++)
		used[i] = 1;
	prev = K;
	long max = prev;
	for (i = K + 1; i <= N; i++){
		if (!(i % 100))
		cout << i << endl;
		Gen();
		if (prev > max)
			max = prev;
		used[prev] = 1;
	}
	for (i = 1; i < MAXINT; i++)
		if (!used[i])
			break;
	cout << i << ' ' << max << ' ' << prev << endl;
}

void Output()
{
}


int main()
{
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
 	cout = os;
		Init();
		Input();
		Solve();
		Output();

	return 0;
}